VERSION 5.00
Begin VB.UserControl MainControl 
   BackStyle       =   0  'Transparent
   ClientHeight    =   4470
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5355
   MaskColor       =   &H00FF00FF&
   ScaleHeight     =   298
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   357
   Windowless      =   -1  'True
   Begin VB.Timer Timer1 
      Interval        =   40
      Left            =   120
      Top             =   120
   End
   Begin VB.Label Label1 
      Caption         =   $"MainControl.ctx":0000
      Height          =   3135
      Left            =   0
      TabIndex        =   0
      Top             =   1440
      Visible         =   0   'False
      Width           =   2295
   End
   Begin VB.Image Sprite 
      Height          =   1440
      Left            =   0
      Picture         =   "MainControl.ctx":01C4
      Stretch         =   -1  'True
      Top             =   0
      Width           =   5355
   End
End
Attribute VB_Name = "MainControl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True

'-------------------------------------------------
'The original version of the code is
'Copyright 2007 Giovanni Albani

'You are allowed to modify and recompile the code
'below, provided that you do so only for use in
'Adventure Maker projects.

'You are allowed to redistribute the source code
'only under the condition that the modified code
'contains this license agreement, all the copyright
'notices currently in place, an explanation of what
'the differences between the original version and
'the modified version are, and makes it clear who
'made the changes and who wrote what code.
'-------------------------------------------------



'OPTIONS:
Option Explicit

'CUSTOM TYPES:
Type Point
    X As Long
    Y As Long
End Type
Type Rectangle
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

'PRIVATE DECLARATIONS:
Private DestinationPoint As Point
Private DestinationPointWithoutAdjustments As Point
Private AllowedArea As Rectangle
Private SpriteSizeLimits As Rectangle

'PRIVATE DECLARATIONS CONCERNING SPRITE ANIMATION:
Private CurrentAngle As Integer
Private CurrentPicture As Integer

Private NumberOfAngles As Integer
Private NumberOfPicturesPerAngle As Integer
Private PicturesPerSecond As Single
Private FilesPath As String
Private PrefixOfFiles As String
Private FilesExtension As String
Private Counter As Integer
Private Horiz_Shift_In_Pixels As Long
Private Vert_Shift_In_Pixels As Long
Private Sprite_Speed As Single
Private StaticPictureIsNumber0 As Boolean

Private Horiz_Shift_Factor As Single
Private Vert_Shift_Factor As Single

Private PictureArray() As StdPicture

'PUBLIC DECLARATIONS:
Public IsWalking As Boolean

Public Sub Resize(ByVal WidthInPixels As Long, ByVal HeightInPixels As Long)
    'RESIZE THE WINDOW:
    Width = WidthInPixels * Screen.TwipsPerPixelX
    Height = HeightInPixels * Screen.TwipsPerPixelY
End Sub

Public Sub SetSpritePosition(ByVal X As Long, ByVal Y As Long, Optional ByVal bDoNotQuitWalkingStatus As Boolean)
    
    'CALCULATE THE SCALE FACTOR THAT CORRESPONDS TO THE SPECIFIED POSITION:
    Dim ScaleFactor As Single
    ScaleFactor = GetScaleFactorFromPosition(X, Y)
    
    'RESIZE SPRITE:
    Sprite.Width = Int(UserControl.ScaleX(Sprite.Picture.Width)) * ScaleFactor
    Sprite.Height = Int(UserControl.ScaleY(Sprite.Picture.Height)) * ScaleFactor
    
    'CHANGE SPRITE COORDINATES:
    Sprite.Left = X - Sprite.Width * Horiz_Shift_Factor
    Sprite.Top = Y - Sprite.Height * Vert_Shift_Factor
    
    'RESET ANIMATION?
    If bDoNotQuitWalkingStatus = False Then
        ShowDefaultPicture
        IsWalking = False
    End If
End Sub

Public Sub SetSpriteSizeInPercent(ByVal Top As Long, ByVal Bottom As Long)
    'SET THE SCALE FACTORS FOR TOP AND BOTTOM OF THE ALLOWED AREA:
    SpriteSizeLimits.Top = IIf(Top = 0, 100, Top)
    SpriteSizeLimits.Bottom = IIf(Bottom = 0, 100, Bottom)
End Sub

Public Sub SetAllowedArea(ByVal Left As Long, ByVal Top As Long, ByVal Right As Long, ByVal Bottom As Long)
    'SET THE AREA IN WHICH THE SPRITE IS ALLOWED TO MOVE:
    AllowedArea.Left = Left
    AllowedArea.Top = Top
    AllowedArea.Right = Right
    AllowedArea.Bottom = Bottom
End Sub

Public Sub MoveSpriteTo(ByVal X As Long, ByVal Y As Long, Optional ByVal CanMoveOutsideAllowedArea As Boolean)
    
    'SET THE DESTINATION POINT (NO MATTER WHERE THE ALLOWED AREA IS):
    DestinationPointWithoutAdjustments.X = X
    DestinationPointWithoutAdjustments.Y = Y

    'FORCE THE SPRITE TO REMAIN IN THE ALLOWED AREA:
    If CanMoveOutsideAllowedArea = False Then
        If X < AllowedArea.Left Then
            X = AllowedArea.Left
        ElseIf X > AllowedArea.Right Then
            X = AllowedArea.Right
        End If
        If Y < AllowedArea.Top Then
            Y = AllowedArea.Top
        ElseIf Y > AllowedArea.Bottom Then
            Y = AllowedArea.Bottom
        End If
    End If
    
    'SET THE DESTINATION POINT:
    DestinationPoint.X = X
    DestinationPoint.Y = Y

    'GET THE CURRENT POSITION
    Dim CurrentPos As Point
    CurrentPos = GetCurrentPosition

    'SPRITE PICTURE:
    CurrentAngle = GetDiscreetAngleFromAngle(PointsToAngle(CurrentPos.X, CurrentPos.Y, DestinationPoint.X, DestinationPoint.Y))
    If StaticPictureIsNumber0 = True Then CurrentPicture = 1
    'Set Sprite.Picture = PictureArray(CurrentAngle, CurrentPicture)   '(causes a flash in the wrong direction when clicking outise the allowed area and the sprite is in the limit of the allowed area)

    IsWalking = True
End Sub

Function GetDiscreetAngleFromAngle(ByVal Angle As Single) As Integer
    Dim AngleSize As Single
    AngleSize = CSng(360 / NumberOfAngles)
    GetDiscreetAngleFromAngle = 1 + Int(AddAngles(Angle, (AngleSize / 2)) / AngleSize)
End Function



Private Sub Timer1_Timer()

    'QUIT IF THE SPRITE IS ALREADY IN THR RIGHT POSITION:
    If IsWalking = False Then Exit Sub

    'DECLARATIONS:
    Dim DistanceToDestinationPoint As Long
    
    'GET THE CURRENT POSITION
    Dim CurrentPos As Point
    CurrentPos = GetCurrentPosition
    
    'CALCULATE DISTANCE BETWEEN SPRITE AND DESTINATION POINT:
    DistanceToDestinationPoint = Sqr((DestinationPoint.X - CurrentPos.X) ^ 2 + (DestinationPoint.Y - CurrentPos.Y) ^ 2)

    'CALCULATE THE SCALED SPEED THAT CORRESPONDS TO THE CURRENT POSITION:
    Dim ScaleSpeed As Single
    ScaleSpeed = Sprite_Speed * GetScaleFactorFromPosition(CurrentPos.X, CurrentPos.Y)
    
    'MOVE SPRITE:
    If DistanceToDestinationPoint > (ScaleSpeed + 1) Then
        SetSpritePosition CurrentPos.X + CLng((DestinationPoint.X - CurrentPos.X) * ScaleSpeed / DistanceToDestinationPoint), CurrentPos.Y + CLng((DestinationPoint.Y - CurrentPos.Y) * ScaleSpeed / DistanceToDestinationPoint), True
        ShowNextPicture
    Else
        SetSpritePosition DestinationPoint.X, DestinationPoint.Y, True
        If StaticPictureIsNumber0 = True Then
            ShowDefaultPicture
        End If
        If DestinationPointWithoutAdjustments.X <> DestinationPoint.X Or DestinationPointWithoutAdjustments.Y <> DestinationPoint.Y Then
            CurrentAngle = GetDiscreetAngleFromAngle(PointsToAngle(CurrentPos.X, CurrentPos.Y, DestinationPointWithoutAdjustments.X, DestinationPointWithoutAdjustments.Y))
            Set Sprite.Picture = PictureArray(CurrentAngle, CurrentPicture)
        End If
        IsWalking = False
    End If
End Sub

Public Property Let TimerInterval(ByVal vData As Integer)
    Timer1.Interval = vData
End Property

Public Property Get TimerInterval() As Integer
    TimerInterval = Timer1.Interval
End Property


Public Sub InitializePictures(ByVal A As Integer, ByVal B As Integer, ByVal C As Single, ByVal d As String, ByVal E As String, ByVal F As String, ByVal G As Long, ByVal H As Long, ByVal K As Single, ByVal L As Boolean)
On Error GoTo ErrorPoint

    Screen.MousePointer = vbHourglass

    'INITIALIZE PARAMETERS:
    NumberOfAngles = A
    NumberOfPicturesPerAngle = B
    PicturesPerSecond = C
    FilesPath = d
    PrefixOfFiles = E
    FilesExtension = F
    Horiz_Shift_In_Pixels = G
    Vert_Shift_In_Pixels = H
    Sprite_Speed = K
    StaticPictureIsNumber0 = L
       
    'LOAD PICTURES INTO MEMORY:
    ReDim PictureArray(NumberOfAngles, NumberOfPicturesPerAngle)
    Dim i As Integer, j As Integer
    For i = 1 To NumberOfAngles
        For j = 0 To NumberOfPicturesPerAngle
            '(generates an error only if not found AND j<>0)
            If Dir(FilesPath + PrefixOfFiles + "_" + Format(i, "00") + "_" + Format(j, "00") + ".gif") <> "" Or j <> 0 Then
                Set PictureArray(i, j) = LoadPicture(FilesPath + PrefixOfFiles + "_" + Format(i, "00") + "_" + Format(j, "00") + ".gif")
            End If
        Next j
    Next i

    'SHIFT VALUE, IN PERCENT:
    Horiz_Shift_Factor = Horiz_Shift_In_Pixels / Int(UserControl.ScaleX(PictureArray(1, 1).Width))
    Vert_Shift_Factor = Vert_Shift_In_Pixels / Int(UserControl.ScaleY(PictureArray(1, 1).Height))
    
    'DEFAULT VALUES:
    CurrentAngle = 1
    
    ShowDefaultPicture
    SetSpritePosition 150, 300 '(useful to stretch)

    Screen.MousePointer = vbNormal
    
Exit Sub
ErrorPoint:
    Screen.MousePointer = vbNormal
    Err.Raise Err.Number
End Sub

Private Sub ShowNextPicture()
    
    Counter = Counter + 1

    Dim PreviousPicture As Integer
    PreviousPicture = CurrentPicture
    
    CurrentPicture = 1 + Int(Counter * Timer1.Interval * PicturesPerSecond / 1000)
    If CurrentPicture > NumberOfPicturesPerAngle Then
        CurrentPicture = 1
        Counter = 0
    End If
    
    If CurrentPicture <> PreviousPicture Then
        Set Sprite.Picture = PictureArray(CurrentAngle, CurrentPicture)
    End If
    
End Sub


Private Sub ShowDefaultPicture()

    CurrentPicture = IIf(StaticPictureIsNumber0 = True, 0, 1)
    Counter = 0
    Set Sprite.Picture = PictureArray(CurrentAngle, CurrentPicture)

End Sub

Private Function GetScaleFactorFromPosition(ByVal X As Long, ByVal Y As Long) As Single
    '(the returned value is in percent)
    If AllowedArea.Bottom <> AllowedArea.Top Then
        GetScaleFactorFromPosition = (SpriteSizeLimits.Bottom + (SpriteSizeLimits.Top - SpriteSizeLimits.Bottom) * (Y - AllowedArea.Bottom) / (AllowedArea.Top - AllowedArea.Bottom)) / 100
    Else
        GetScaleFactorFromPosition = 1
    End If
End Function

Private Function GetCurrentPosition() As Point
    'RETURNS THE CURRENT POSITION OF THE SPRITE (NOT OF THE IMAGE CONTROL):
    GetCurrentPosition.X = Sprite.Left + Sprite.Width * Horiz_Shift_Factor
    GetCurrentPosition.Y = Sprite.Top + Sprite.Height * Vert_Shift_Factor
End Function

Public Sub SetSpriteOrientation(ByVal Orientation As Single)
    'MAKE SURE IT IS BETWEEN 0 AND 12:
    Orientation = (24 + Orientation) Mod 12
    
    'CONVERT TO AN ANGLE:
    Orientation = AddAngles((360 - Orientation * 360 / 12), 180)
    
    'SET THE CURRENT DISCREET ANGLE:
    CurrentAngle = GetDiscreetAngleFromAngle(Orientation)
    Set Sprite.Picture = PictureArray(CurrentAngle, CurrentPicture)
    
End Sub

